using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using System.Data.SqlClient;
using System.Threading;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_EmpleadosFiscal_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 2;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                   " SELECT " +
                         nameof(MAE_EmpleadosFiscal.id) + "," +
                         nameof(MAE_EmpleadosFiscal.idEmpleado) + "," +
                         nameof(MAE_EmpleadosFiscal.numeroAfiliacion) + "," +
                         nameof(MAE_EmpleadosFiscal.anyoNacimiento) + "," +
                         nameof(MAE_EmpleadosFiscal.tipoContrato) + "," +
                         nameof(MAE_EmpleadosFiscal.situacionFamiliar) + "," +
                         nameof(MAE_EmpleadosFiscal.nif_Conyuge) + "," +
                         nameof(MAE_EmpleadosFiscal.discapacidad) + "," +
                         nameof(MAE_EmpleadosFiscal.movilidadGeografica) + "," +
                         nameof(MAE_EmpleadosFiscal.obtencionRendimientos) + "," +
                         nameof(MAE_EmpleadosFiscal.pension_Compensatoria_Conyuge) + "," +
                         nameof(MAE_EmpleadosFiscal.pension_Anualidades_hijos) + "," +
                         nameof(MAE_EmpleadosFiscal.pagos_ViviendaHabitual_ConDerechoDeduccionIRPF) +
                  " FROM " + nameof(MAE_EmpleadosFiscal) +
                  " WHERE " + nameof(MAE_EmpleadosFiscal.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MAE_EmpleadosFiscal>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_EmpleadosFiscal_Descendientes ####################################################################################################
                    ThreadStart obj_ThreadStart_EMPLEADOSFISCALDESCENDIENTES = new ThreadStart(Obtener_EmpleadosFiscalDescendientes_Modelo_Listado_Obtener);
                    Thread obj_Thread_EMPLEADOSFISCALDESCENDIENTES = new Thread(obj_ThreadStart_EMPLEADOSFISCALDESCENDIENTES);
                    obj_Thread_EMPLEADOSFISCALDESCENDIENTES.Start();

                    //MAE_EmpleadosFiscal_Ascendientes ####################################################################################################
                    ThreadStart obj_ThreadStart_EMPLEADOSFISCALASCENDIENTES = new ThreadStart(Obtener_EmpleadosFiscalAscendientes_Modelo_Listado_OBtener);
                    Thread obj_Thread_EMPLEADOSFISCALASCENDIENTES = new Thread(obj_ThreadStart_EMPLEADOSFISCALASCENDIENTES);
                    obj_Thread_EMPLEADOSFISCALASCENDIENTES.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_EmpleadosFiscal_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_EmpleadosFiscalDescendientes_Modelo_Listado_Obtener()
        {
            try
            {
                MAE_EmpleadosFiscal_Descendientes_Datos obj_MAE_EmpleadosFiscal_Descendientes_Datos = new MAE_EmpleadosFiscal_Descendientes_Datos();
                g_dnm_Modelo_Obtener.MAE_EmpleadosFiscal_Descendientes = obj_MAE_EmpleadosFiscal_Descendientes_Datos.Obtener_ModeloListado_Por_IdEmpleadoFiscal(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_EmpleadosFiscalAscendientes_Modelo_Listado_OBtener()
        {
            try
            {
                MAE_EmpleadosFiscal_Ascendientes_Datos obj_MAE_EmpleadosFiscal_Ascendientes_Datos = new MAE_EmpleadosFiscal_Ascendientes_Datos();
                g_dnm_Modelo_Obtener.MAE_EmpleadosFiscal_Ascendientes = obj_MAE_EmpleadosFiscal_Ascendientes_Datos.Obtener_ModeloListado_Por_IdEmpleadoFiscal(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MAE_EmpleadosFiscal g_mdl_MAE_EmpleadosFiscal = null;
        public MAE_EmpleadosFiscal Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MAE_EmpleadosFiscal) + "." + nameof(MAE_EmpleadosFiscal.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_EmpleadosFiscal_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_EmpleadosFiscal;
        }

        public MAE_EmpleadosFiscal Obtener_Modelo_Por_IdEmpleado(long _lng_idEmpleado,
                                                                bool _bol_Cargar_EmpleadoFiscalDescendientes,
                                                                bool _bol_Cargar_EmpleadoFiscalAscendientes)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MAE_EmpleadosFiscal) + "." + nameof(MAE_EmpleadosFiscal.idEmpleado) + "=@idEmpleado";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_EmpleadosFiscal_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_EmpleadosFiscal;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                               object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_MAE_EmpleadosFiscal = obj_Exferia_Entities.Database.SqlQuery<MAE_EmpleadosFiscal>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_EmpleadosFiscal_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();

            }
        }
        #endregion

        #region Modelo Listado
        private List<MAE_EmpleadosFiscal> g_lst_MAE_EmpleadosFiscal = null;

        public List<MAE_EmpleadosFiscal> Obtener_ModeloListado_Por_IdEmpleado(long _lng_idEmpleado,
                                                                              bool _bol_Cargar_EmpleadoFiscalDescendientes,
                                                                              bool _bol_Cargar_EmpleadoFiscalAscendientes)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MAE_EmpleadosFiscal) + "." + nameof(MAE_EmpleadosFiscal.idEmpleado) + "=@idEmpleado";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 _bol_Cargar_EmpleadoFiscalDescendientes,
                                                 _bol_Cargar_EmpleadoFiscalAscendientes);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_EmpleadosFiscal_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdEmpleado), true);
            }

            return g_lst_MAE_EmpleadosFiscal;
        }

        #region Ejecutar consulta
        //Listado de modelos Relacionados
        private List<MAE_EmpleadosFiscal_Ascendientes> g_lst_MAE_EmpleadosFiscal_Ascendientes = null;
        private List<MAE_EmpleadosFiscal_Descendientes> g_lst_MAE_EmpleadosFiscal_Descendientes = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 2;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros,
                                                    bool _bol_Cargar_EmpleadoFiscalDescendientes,
                                                    bool _bol_Cargar_EmpleadoFiscalAscendientes)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MAE_EmpleadosFiscal = obj_Exferia_Entities.Database.SqlQuery<MAE_EmpleadosFiscal>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_MAE_EmpleadosFiscal != null && g_lst_MAE_EmpleadosFiscal.Count > 0)
                {
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_EmpleadoFiscalDescendientes ||
                        _bol_Cargar_EmpleadoFiscalAscendientes)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //MAE_EmpleadosFiscal_Descendientes #############################################
                        if (_bol_Cargar_EmpleadoFiscalDescendientes)
                        {
                            ThreadStart obj_ThreadStart_EMPLEADOSFISCALDESCENDIENTES = new ThreadStart(Obtener_EmpleadosFiscalDescendientes_Modelo_Listado);
                            Thread obj_Thread_EMPLEADOSFISCALDESCENDIENTES = new Thread(obj_ThreadStart_EMPLEADOSFISCALDESCENDIENTES);
                            obj_Thread_EMPLEADOSFISCALDESCENDIENTES.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //MAE_EmpleadosFiscal_Ascendientes #############################################
                        if (_bol_Cargar_EmpleadoFiscalAscendientes)
                        {
                            ThreadStart obj_ThreadStart_EMPLEADOSFISCALASCENCIENTES = new ThreadStart(Obtener_EmpleadosFiscalAscendientes_Modelo_Listado);
                            Thread obj_Thread_EMPLEADOSFISCALASCENCIENTES = new Thread(obj_ThreadStart_EMPLEADOSFISCALASCENCIENTES);
                            obj_Thread_EMPLEADOSFISCALASCENCIENTES.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................

                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (MAE_EmpleadosFiscal mdl_MAE_EmpleadosFiscal in g_lst_MAE_EmpleadosFiscal)
                        {
                            //MAE_EmpleadosFiscal_Ascendientes #############################################
                            if (_bol_Cargar_EmpleadoFiscalAscendientes &&
                                g_lst_MAE_EmpleadosFiscal_Ascendientes != null &&
                                g_lst_MAE_EmpleadosFiscal_Ascendientes.Count > 0)
                            {
                                mdl_MAE_EmpleadosFiscal.MAE_EmpleadosFiscal_Ascendientes = g_lst_MAE_EmpleadosFiscal_Ascendientes.Where(m => m.id == mdl_MAE_EmpleadosFiscal.id).ToList();
                            }

                            //MAE_EmpleadosFiscal_Descendientes #############################################
                            if (_bol_Cargar_EmpleadoFiscalDescendientes &&
                                g_lst_MAE_EmpleadosFiscal_Descendientes != null &&
                                g_lst_MAE_EmpleadosFiscal_Descendientes.Count > 0)
                            {
                                mdl_MAE_EmpleadosFiscal.MAE_EmpleadosFiscal_Descendientes = g_lst_MAE_EmpleadosFiscal_Descendientes.Where(m => m.id == mdl_MAE_EmpleadosFiscal.id).ToList();
                            }
                        }
                        #endregion
                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_EmpleadosFiscal_Descendientes_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_EmpleadosFiscalDescendientes_Modelo_Listado()
        {
            try
            {
                MAE_EmpleadosFiscal_Descendientes_Datos obj_MAE_EmpleadosFiscal_Descendientes_Datos = new MAE_EmpleadosFiscal_Descendientes_Datos();
                g_lst_MAE_EmpleadosFiscal_Descendientes = obj_MAE_EmpleadosFiscal_Descendientes_Datos.Obtener_ModeloListado_Por_IdsEmpleadoFiscal(g_lst_MAE_EmpleadosFiscal.Select(m => m.id).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        private void Obtener_EmpleadosFiscalAscendientes_Modelo_Listado()
        {
            try
            {
                MAE_EmpleadosFiscal_Ascendientes_Datos obj_MAE_EmpleadosFiscal_Ascendientes_Datos = new MAE_EmpleadosFiscal_Ascendientes_Datos();
                g_lst_MAE_EmpleadosFiscal_Ascendientes = obj_MAE_EmpleadosFiscal_Ascendientes_Datos.Obtener_ModeloListado_Por_IdsEmpleadoFiscal(g_lst_MAE_EmpleadosFiscal.Select(m => m.id).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
            }
        }
        #endregion

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                        nameof(MAE_EmpleadosFiscal.id) + "," +
                        nameof(MAE_EmpleadosFiscal.idEmpleado) + "," +
                        nameof(MAE_EmpleadosFiscal.numeroAfiliacion) + "," +
                        nameof(MAE_EmpleadosFiscal.anyoNacimiento) + "," +
                        nameof(MAE_EmpleadosFiscal.tipoContrato) + "," +
                        nameof(MAE_EmpleadosFiscal.situacionFamiliar) + "," +
                        nameof(MAE_EmpleadosFiscal.nif_Conyuge) + "," +
                        nameof(MAE_EmpleadosFiscal.discapacidad) + "," +
                        nameof(MAE_EmpleadosFiscal.movilidadGeografica) + "," +
                        nameof(MAE_EmpleadosFiscal.obtencionRendimientos) + "," +
                        nameof(MAE_EmpleadosFiscal.pension_Compensatoria_Conyuge) + "," +
                        nameof(MAE_EmpleadosFiscal.pension_Anualidades_hijos) + "," +
                        nameof(MAE_EmpleadosFiscal.pagos_ViviendaHabitual_ConDerechoDeduccionIRPF) +
                " FROM " + nameof(MAE_EmpleadosFiscal);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MAE_EmpleadosFiscal mdl_MAE_EmpleadosFisca_AGrabar = (MAE_EmpleadosFiscal)_mdl_obj;
                MAE_EmpleadosFiscal mdl_MAE_EmpleadosFiscal_DatosViejos = new MAE_EmpleadosFiscal();

                // Ver si existe ######################################################################
                MAE_EmpleadosFiscal mdl_MAE_EmpleadosFiscal_Final = Obtener_Modelo_Por_Id(mdl_MAE_EmpleadosFisca_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_MAE_EmpleadosFiscal_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_EmpleadosFiscal_Final, mdl_MAE_EmpleadosFiscal_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_EmpleadosFisca_AGrabar, mdl_MAE_EmpleadosFiscal_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MAE_EmpleadosFiscal) +
                                            " SET " +
                                                nameof(MAE_EmpleadosFiscal.idEmpleado) + "=@idEmpleado," +
                                                nameof(MAE_EmpleadosFiscal.numeroAfiliacion) + "=@numeroAfiliacion," +
                                                nameof(MAE_EmpleadosFiscal.anyoNacimiento) + "=@anyoNacimiento," +
                                                nameof(MAE_EmpleadosFiscal.tipoContrato) + "=@tipoContrato," +
                                                nameof(MAE_EmpleadosFiscal.situacionFamiliar) + "=@situacionFamiliar," +
                                                nameof(MAE_EmpleadosFiscal.nif_Conyuge) + "=@nif_Conyuge," +
                                                nameof(MAE_EmpleadosFiscal.discapacidad) + "=@discapacidad," +
                                                nameof(MAE_EmpleadosFiscal.movilidadGeografica) + "=@movilidadGeografica," +
                                                nameof(MAE_EmpleadosFiscal.obtencionRendimientos) + "=@obtencionRendimientos," +
                                                nameof(MAE_EmpleadosFiscal.pension_Compensatoria_Conyuge) + "=@pension_Compensatoria_Conyuge," +
                                                nameof(MAE_EmpleadosFiscal.pension_Anualidades_hijos) + "=@pension_Anualidades_hijos," +
                                                nameof(MAE_EmpleadosFiscal.pagos_ViviendaHabitual_ConDerechoDeduccionIRPF) + "=@pagos_ViviendaHabitual_ConDerechoDeduccionIRPF" +
                                            " WHERE " +
                                                nameof(MAE_EmpleadosFiscal.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idEmpleado",  mdl_MAE_EmpleadosFiscal_Final.idEmpleado),
                        mdl_MAE_EmpleadosFiscal_Final.numeroAfiliacion != null
                            ?   new SqlParameter("@numeroAfiliacion", mdl_MAE_EmpleadosFiscal_Final.numeroAfiliacion)
                            :   new SqlParameter("@numeroAfiliacion",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.anyoNacimiento != null
                            ?   new SqlParameter("@anyoNacimiento", mdl_MAE_EmpleadosFiscal_Final.anyoNacimiento.Value)
                            :   new SqlParameter("@anyoNacimiento",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.tipoContrato != null
                            ?   new SqlParameter("@tipoContrato", mdl_MAE_EmpleadosFiscal_Final.tipoContrato)
                            :   new SqlParameter("@tipoContrato",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.situacionFamiliar != null
                            ?   new SqlParameter("@situacionFamiliar", mdl_MAE_EmpleadosFiscal_Final.situacionFamiliar)
                            :   new SqlParameter("@situacionFamiliar",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.nif_Conyuge != null
                            ?   new SqlParameter("@nif_Conyuge", mdl_MAE_EmpleadosFiscal_Final.nif_Conyuge)
                            :   new SqlParameter("@nif_Conyuge",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.discapacidad != null
                            ?   new SqlParameter("@discapacidad", mdl_MAE_EmpleadosFiscal_Final.discapacidad)
                            :   new SqlParameter("@discapacidad",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.movilidadGeografica != null
                            ?   new SqlParameter("@movilidadGeografica", mdl_MAE_EmpleadosFiscal_Final.movilidadGeografica.Value)
                            :   new SqlParameter("@movilidadGeografica",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.obtencionRendimientos != null
                            ?   new SqlParameter("@obtencionRendimientos", mdl_MAE_EmpleadosFiscal_Final.obtencionRendimientos.Value)
                            :   new SqlParameter("@obtencionRendimientos",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.pension_Compensatoria_Conyuge != null
                            ?   new SqlParameter("@pension_Compensatoria_Conyuge", mdl_MAE_EmpleadosFiscal_Final.pension_Compensatoria_Conyuge.Value)
                            :   new SqlParameter("@pension_Compensatoria_Conyuge",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.pension_Anualidades_hijos != null
                            ?   new SqlParameter("@pension_Anualidades_hijos", mdl_MAE_EmpleadosFiscal_Final.pension_Anualidades_hijos.Value)
                            :   new SqlParameter("@pension_Anualidades_hijos",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.pagos_ViviendaHabitual_ConDerechoDeduccionIRPF != null
                            ?   new SqlParameter("@pagos_ViviendaHabitual_ConDerechoDeduccionIRPF", mdl_MAE_EmpleadosFiscal_Final.pagos_ViviendaHabitual_ConDerechoDeduccionIRPF.Value)
                            :   new SqlParameter("@pagos_ViviendaHabitual_ConDerechoDeduccionIRPF",  DBNull.Value),
                        new SqlParameter("@id", mdl_MAE_EmpleadosFiscal_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_MAE_EmpleadosFiscal_Final.id;
                }
                //INSERT
                else
                {
                    mdl_MAE_EmpleadosFiscal_Final = new MAE_EmpleadosFiscal();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_EmpleadosFisca_AGrabar, mdl_MAE_EmpleadosFiscal_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_EmpleadosFiscal) +
                                                " (" +
                                                        nameof(MAE_EmpleadosFiscal.idEmpleado) + "," +
                                                        nameof(MAE_EmpleadosFiscal.numeroAfiliacion) + "," +
                                                        nameof(MAE_EmpleadosFiscal.anyoNacimiento) + "," +
                                                        nameof(MAE_EmpleadosFiscal.tipoContrato) + "," +
                                                        nameof(MAE_EmpleadosFiscal.situacionFamiliar) + "," +
                                                        nameof(MAE_EmpleadosFiscal.nif_Conyuge) + "," +
                                                        nameof(MAE_EmpleadosFiscal.discapacidad) + "," +
                                                        nameof(MAE_EmpleadosFiscal.movilidadGeografica) + "," +
                                                        nameof(MAE_EmpleadosFiscal.obtencionRendimientos) + "," +
                                                        nameof(MAE_EmpleadosFiscal.pension_Compensatoria_Conyuge) + "," +
                                                        nameof(MAE_EmpleadosFiscal.pension_Anualidades_hijos) + "," +
                                                        nameof(MAE_EmpleadosFiscal.pagos_ViviendaHabitual_ConDerechoDeduccionIRPF) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(MAE_EmpleadosFiscal.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idEmpleado," +
                                                    "@numeroAfiliacion," +
                                                    "@anyoNacimiento," +
                                                    "@tipoContrato," +
                                                    "@situacionFamiliar," +
                                                    "@nif_Conyuge," +
                                                    "@discapacidad," +
                                                    "@movilidadGeografica," +
                                                    "@obtencionRendimientos," +
                                                    "@pension_Compensatoria_Conyuge," +
                                                    "@pension_Anualidades_hijos," +
                                                    "@pagos_ViviendaHabitual_ConDerechoDeduccionIRPF" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                       new SqlParameter("@idEmpleado",  mdl_MAE_EmpleadosFiscal_Final.idEmpleado),
                        mdl_MAE_EmpleadosFiscal_Final.numeroAfiliacion != null
                            ?   new SqlParameter("@numeroAfiliacion", mdl_MAE_EmpleadosFiscal_Final.numeroAfiliacion)
                            :   new SqlParameter("@numeroAfiliacion",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.anyoNacimiento != null
                            ?   new SqlParameter("@anyoNacimiento", mdl_MAE_EmpleadosFiscal_Final.anyoNacimiento.Value)
                            :   new SqlParameter("@anyoNacimiento",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.tipoContrato != null
                            ?   new SqlParameter("@tipoContrato", mdl_MAE_EmpleadosFiscal_Final.tipoContrato)
                            :   new SqlParameter("@tipoContrato",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.situacionFamiliar != null
                            ?   new SqlParameter("@situacionFamiliar", mdl_MAE_EmpleadosFiscal_Final.situacionFamiliar)
                            :   new SqlParameter("@situacionFamiliar",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.nif_Conyuge != null
                            ?   new SqlParameter("@nif_Conyuge", mdl_MAE_EmpleadosFiscal_Final.nif_Conyuge)
                            :   new SqlParameter("@nif_Conyuge",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.discapacidad != null
                            ?   new SqlParameter("@discapacidad", mdl_MAE_EmpleadosFiscal_Final.discapacidad)
                            :   new SqlParameter("@discapacidad",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.movilidadGeografica != null
                            ?   new SqlParameter("@movilidadGeografica", mdl_MAE_EmpleadosFiscal_Final.movilidadGeografica.Value)
                            :   new SqlParameter("@movilidadGeografica",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.obtencionRendimientos != null
                            ?   new SqlParameter("@obtencionRendimientos", mdl_MAE_EmpleadosFiscal_Final.obtencionRendimientos.Value)
                            :   new SqlParameter("@obtencionRendimientos",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.pension_Compensatoria_Conyuge != null
                            ?   new SqlParameter("@pension_Compensatoria_Conyuge", mdl_MAE_EmpleadosFiscal_Final.pension_Compensatoria_Conyuge.Value)
                            :   new SqlParameter("@pension_Compensatoria_Conyuge",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.pension_Anualidades_hijos != null
                            ?   new SqlParameter("@pension_Anualidades_hijos", mdl_MAE_EmpleadosFiscal_Final.pension_Anualidades_hijos.Value)
                            :   new SqlParameter("@pension_Anualidades_hijos",  DBNull.Value),
                        mdl_MAE_EmpleadosFiscal_Final.pagos_ViviendaHabitual_ConDerechoDeduccionIRPF != null
                            ?   new SqlParameter("@pagos_ViviendaHabitual_ConDerechoDeduccionIRPF", mdl_MAE_EmpleadosFiscal_Final.pagos_ViviendaHabitual_ConDerechoDeduccionIRPF.Value)
                            :   new SqlParameter("@pagos_ViviendaHabitual_ConDerechoDeduccionIRPF",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_EmpleadosFiscal_Datos), mdl_MAE_EmpleadosFiscal_DatosViejos, mdl_MAE_EmpleadosFiscal_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_EmpleadosFiscal_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MAE_EmpleadosFiscal mdl_MAE_EmpleadosFiscal_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_MAE_EmpleadosFiscal_Final != null)
                {
                    #region Delete
                    string str_SQL_Delete = " DELETE FROM  " + nameof(MAE_EmpleadosFiscal) +
                                            " WHERE " +
                                                nameof(MAE_EmpleadosFiscal.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Delete
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                    //Grabar un registro de trazabailidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_EmpleadosFiscal), null, mdl_MAE_EmpleadosFiscal_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                // Devolver también el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_EmpleadosFiscal_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
